<!-- Writen by Brian Leonard: http://www.bleonard.com                    -->
<!-- Adapted from MapIt! by Jason Heddings: http://mapit.mozdev.org/     -->
<!-- License: http://creativecommons.org/licenses/by-nc-sa/2.0/          -->

var gAddress = null;
var gMapItSettings = null;
var gDirections = 0;
var gChoice = 0;
var gMethod = 0;

////////////////////////////////////////////////////////////////////////////////
// Attempt to read address from selected text.

// var directions: indicates if the map should be driving directions
// 0 - do not show directions
// 1 - show directions to location from saved address
// 2 - show directions from location to saved address

// var addressChoice
// 0 - not used
// 1- home address
// 2 - work address

// var method
// 0 - not used
// 1 - ride
// 2 - drive
function mapitSelectedText(directions,addressChoice,method) {
  if (gAddress == null) {
    alert("how'd this happen?");
  }

  gDirections = directions;
  gChoice = addressChoice;
  gMethod = method;
  showAddress(gAddress);
}
//////////////////////////////////
// converts from settings to a address

function getAddressFromSettings(choice) {
	var val = null;
	if(choice==2) {
		val = "";
		if(gMapItSettings.workStreet) {
			val += gMapItSettings.workStreet;
		}
		if(gMapItSettings.workCity) {
			if(val.length>0) val += " ";
			val += gMapItSettings.workCity;
		}
		if(gMapItSettings.workState) {
			if(val.length>0) val += ", ";
			val += gMapItSettings.workState;
		}
		if(gMapItSettings.workZip) {
			if(val.length>0) val += " ";
			val += gMapItSettings.workZip;
		}
	}
	else {
		val="";
		if(gMapItSettings.homeStreet) {
			val += gMapItSettings.homeStreet;
		}
		if(gMapItSettings.homeCity) {
			if(val.length>0) val += " ";
			val += gMapItSettings.homeCity;
		}
		if(gMapItSettings.homeState) {
			if(val.length>0) val += ", ";
			val += gMapItSettings.homeState;
		}
		if(gMapItSettings.homeZip) {
			if(val.length>0) val += " ";
			val += gMapItSettings.homeZip;
		}
	}
	return val;
}
////////////////////////////////////////////////////////////////////////////////
// Map a specific address.

function showAddress(address) {
  if (address==null) {
	 alert("not valid!");
    return;
  }
  // set up the default second address (if we should)
  var dfault = null;

 if( gDirections !=0 && gChoice != 0 )
	{
		dfault = getAddressFromSettings(gChoice);
	}
  else
    {
	   gDirections = 0;
    }
  
  // figure out which is the to & from addresses
  var to = (gDirections == 1) ? address : dfault;
  var from = (gDirections == 2) ? address : dfault;
  
  if(gDirections == 0) 
       mapitGetShowMapForm(address)
  else
	  mapitGetDirectionsForm(to, from, gMethod);
}


function readAddress() {
  // var addr = window.getSelection().toString();
  // var addr =  window._content.__proto__.getSelection.call(window._content).toString();
  var addr =  window._content.getSelection.call(window._content).toString();
  if(addr==null || addr.length==0)
  	 addr = null;
  else	{
   addr = addr.replace(/\n/g," ");	// line breaks with spaces
   addr = addr.replace(/[^A-Za-z0-9 .,-]/g,"");   // other junk
  }
  return addr;
}

////////////////////////////////////////////////////////////////////////////////
// Called when dialog popup is displayed.

function showMapItPopup(isFromMapItMenu) {
  if (gMapItSettings == null) {
    gMapItSettings = new MapItSettings();
  }

  gAddress = readAddress();
  if (!isFromMapItMenu) {
    // remove the mapit options from the menu if they shouldn't be there
    document.getElementById("mbta-context-menu").hidden = (gAddress==null);
  }
}

////////////////////////////////////////////////////////////////////////////////
// Called when dialog popup is hidden.

function hideMapItPopup(isFromMapItMenu) {
}



function showCorrectMenus()
{
  if (gMapItSettings == null) {
    gMapItSettings = new MapItSettings();
  }	
	// make sure we show the right ones
	// home address ok?
	if(gMapItSettings.homeCity==null || 0==gMapItSettings.homeCity.length)
	{	// not filled out, hide all
		document.getElementById("mbta-ride-to-home").hidden = true;
		document.getElementById("mbta-ride-from-home").hidden = true;
		document.getElementById("mbta-drive-to-home").hidden = true;
		document.getElementById("mbta-drive-from-home").hidden = true;	
	}
	else
	{	// pick the right ones
		//var homeName = gMapitSettings.homeName;
		//if(0==homeName.length)
			//homeName = "Address One";
		// ride
		if(!gMapItSettings.homeRide)
		{
			document.getElementById("mbta-ride-to-home").hidden = true;	
			document.getElementById("mbta-ride-from-home").hidden = true;
		}
		else
		{	// replace HOME with homeName
			document.getElementById("mbta-ride-to-home").hidden=false;
			document.getElementById("mbta-ride-from-home").hidden=false;
			// really should get from DTD
			test = "Ride here from " + gMapItSettings.homeName;
			document.getElementById("mbta-ride-to-home").label = test;
			test = "Ride from here to " + gMapItSettings.homeName;
			document.getElementById("mbta-ride-from-home").label = test;			
		}
		
		// drive
		if(!gMapItSettings.homeDrive)
		{
			document.getElementById("mbta-drive-to-home").hidden = true;	
			document.getElementById("mbta-drive-from-home").hidden = true;
		}
		else
		{	// replace HOME with homeName
			document.getElementById("mbta-drive-to-home").hidden=false;
			document.getElementById("mbta-drive-from-home").hidden=false;
			// really should get from DTD
			test = "Drive here from " + gMapItSettings.homeName;
			document.getElementById("mbta-drive-to-home").label = test;
			test = "Drive from here to " + gMapItSettings.homeName;
			document.getElementById("mbta-drive-from-home").label = test;					
		}				
	}

	// work address ok?
	if(gMapItSettings.workCity==null || 0==gMapItSettings.workCity.length)
	{	// not filled out, hide all
		document.getElementById("mbta-ride-to-work").hidden = true;
		document.getElementById("mbta-ride-from-work").hidden = true;
		document.getElementById("mbta-drive-to-work").hidden = true;
		document.getElementById("mbta-drive-from-work").hidden = true;	
	}
	else
	{	// pick the right ones
		//var workName = gMapitSettings.workName;
		//if(0==workName.length)
			//workName = "mbta.options.home.label";
			//workName = "Address2";
		// ride
		if(!gMapItSettings.workRide)
		{
			document.getElementById("mbta-ride-to-work").hidden = true;	
			document.getElementById("mbta-ride-from-work").hidden = true;
		}
		else
		{	// replace WORK with workName			
			document.getElementById("mbta-ride-to-work").hidden = false;
			document.getElementById("mbta-ride-from-work").hidden=false;
			//test = document.getElementById("mbta-ride-to-work").label;
			//test = test.replace("WORK",gMapItSettings.workName);
			// really should get from DTD
			test = "Ride here from " + gMapItSettings.workName;
			document.getElementById("mbta-ride-to-work").label = test;
			test = "Ride from here to " + gMapItSettings.workName;
			document.getElementById("mbta-ride-from-work").label = test;
			
	}
		
		// drive
		if(!gMapItSettings.workDrive)
		{
			document.getElementById("mbta-drive-to-work").hidden = true;	
			document.getElementById("mbta-drive-from-work").hidden = true;
		}
		else
		{	// replace WORK with workName
			document.getElementById("mbta-drive-to-work").hidden=false;
			document.getElementById("mbta-drive-from-work").hidden=false;
			// really should get from DTD
			test = "Drive here from " + gMapItSettings.workName;
			document.getElementById("mbta-drive-to-work").label = test;
			test = "Drive from here to " + gMapItSettings.workName;
			document.getElementById("mbta-drive-from-work").label = test;
		}				
	}		
}

function dateIsSpecific(isS) {
	document.getElementById("time-date-grid-relative").hidden = isS;	
	document.getElementById("time-date-grid-specific").hidden = !isS;	
}
function timeIsSpecific(isS) {
	document.getElementById("time-time-grid-relative").hidden = isS;	
	document.getElementById("time-time-grid-specific").hidden = !isS;	
}


function makeItDay(date,dayNum) {
	// dayNum sunday = 0;
	var retDate = new Date(date.getTime());
	day = date.getDay();
	if(day!=dayNum)
	{
		daysAdd = dayNum-day;
		if(daysAdd<0)
			daysAdd=7+daysAdd;
		retDate.setTime(retDate.getTime()+daysAdd*24*60*60*1000)
	}
	return retDate;
}

function getTravelTime() {
	if (gMapItSettings == null) {
		gMapItSettings = new MapItSettings();
	}	
	var time = new Date();
	var now = new Date();
	// number of days to add if the time is already occured
	addDaysIfBefore = 0;
	
	if(gMapItSettings.timeDateType=="dateS")
	{
		time = new Date(parseInt(gMapItSettings.timeYear),
						parseInt(gMapItSettings.timeMonth)-1,
						parseInt(gMapItSettings.timeDay),
						time.getHours(),time.getMinutes(),0);
	}
	else
	{	// relative
		switch(gMapItSettings.timeDateRel)
		{
			case "today":
				addDaysIfBefore = 1;
				break;
			case "tomorrow":
				time.setTime(time.getTime()+24*60*60*1000);
				break;
			case "weekday":
				weekday = time.getDay();
				if(weekday==0 || weekday==6)	// sun or sat
					time = makeItDay(time,1); // make it monday
				else if(weekday==5)	// friday
					addDaysIfBefore = 3;
				else
					addDaysIfBefore = 1;
				break;
			case "weekend":
				weekend = time.getDay();
				if(weekend==0) // sun
					addDaysIfBefore = 6;
				else if(weekend==6)	// sat
					addDaysIfBefore = 1;
				else
					time = makeItDay(time,6); // make it sat
				break;			
			case "sun":
				if(time.getDay()==0)
					addDaysIfBefore=7;
				else
					time = makeItDay(time,0);
				break;
			case "mon":
				if(time.getDay()==1)
					addDaysIfBefore=7;
				else
					time = makeItDay(time,1);
				break;
			case "tues":
				if(time.getDay()==2)
					addDaysIfBefore=7;
				else
					time = makeItDay(time,2);
				break;				
			case "wed":
				if(time.getDay()==3)
					addDaysIfBefore=7;
				else
					time = makeItDay(time,3);
				break;				
			case "thur":
				if(time.getDay()==4)
					addDaysIfBefore=7;
				else
					time = makeItDay(time,4);
				break;				
			case "fri":
				if(time.getDay()==5)
					addDaysIfBefore=7;
				else
				time = makeItDay(time,5);
				break;				
			case "sat":
				if(time.getDay()==6)
					addDaysIfBefore=7;
				else
					time = makeItDay(time,6);
				break;				
			default:
				// tomorrow
				time.setTime(time.getTime()+24*60*60*1000);
				break;
		}
	}
	
	if(gMapItSettings.timeTimeType!="timeR")
	{
		hours = parseInt(gMapItSettings.timeHour);
		if(hours==12)
		{
			if(gMapItSettings.timeAmPm=="PM")
				hours = 12;
			else
				hours = 0;
		}
		else if(gMapItSettings.timeAmPm=="PM")
			hours += 12;
		time.setHours(hours);
		time.setMinutes(parseInt(gMapItSettings.timeMinute));
	}
	else
	{	// relative to what time already is
		switch(gMapItSettings.timeTimeRel)
		{
			case "now":
				time.setTime(time.getTime()+1*60*1000);	// in one minute
				break;
			case "add15":
				time.setTime(time.getTime()+15*60*1000);
				break;
			case "add30":
				time.setTime(time.getTime()+30*60*1000);
				break;
			case "add45":
				time.setTime(time.getTime()+45*60*1000);
				break;
			case "add60":
				time.setTime(time.getTime()+60*60*1000);
				break;
			case "add90":
				time.setTime(time.getTime()+90*60*1000);
				break;
			case "add120":
				time.setTime(time.getTime()+120*60*1000);
				break;
			case "add180":
				time.setTime(time.getTime()+180*60*1000);
				break;
			case "next1":
				time.setTime(time.getTime()+60*60*1000);
				time.setMinutes(0);
				break;
			case "next2":
				time.setTime(time.getTime()+2*60*60*1000);
				time.setMinutes(0);
				break;
			case "next3":
				time.setTime(time.getTime()+3*60*60*1000);
				time.setMinutes(0);
				break;
			case "work95":
				// 9am -> 9   , 5pm -> 17
				hour = time.getHours();
				if( hour < 9 || hour > 17 )
					time.setHours(9);
				else
					time.setHours(17);
				time.setMinutes(0);
				break;
			case "work85":
				// 8am -> 8   , 5pm -> 17
				hour = time.getHours();
				if( hour < 8 || hour > 17 )
					time.setHours(8);
				else
					time.setHours(17);
				time.setMinutes(0);
				break;
			case "work96":
				// 9am -> 9   , 6pm -> 18
				hour = time.getHours();
				if( hour < 9 || hour > 18 )
					time.setHours(9);
				else
					time.setHours(18);
				time.setMinutes(0);
				break;
			default:
				time.setTime(time.getTime()+15*60*1000);
				break;				
		}
	}
	if(time.getTime() < now.getTime()) {
		if(addDaysIfBefore>0)
			time.setTime(time.getTime()+addDaysIfBefore*24*60*60*1000);
	}
	return time;
}

function timeLoadDialog() {
  	var time = getTravelTime();
  	if (time != null) {
		document.getElementById("verify-month").value = "" + (time.getMonth()+1);
		document.getElementById("verify-day").value = "" + time.getDate();
		document.getElementById("verify-year").value = "" + time.getFullYear();
		document.getElementById("verify-minute").value = "" + time.getMinutes();
		
		temp = time.getHours();
		if(temp>11)
			document.getElementById("verify-ampm").value = "PM"
		else
			document.getElementById("verify-ampm").value = "AM"
		if(temp==0 || temp==12)
			document.getElementById("verify-hour").value = "12";
		else if(temp>12)
			document.getElementById("verify-hour").value = "" + (temp-12);
		else
			document.getElementById("verify-hour").value = "" + temp;
   	}
	
	if (gMapItSettings == null) {
		gMapItSettings = new MapItSettings();
	}	
	document.getElementById("verify-arrdep").selectedItem = document.getElementById(gMapItSettings.timeArrDep);
}

function timeDialog() {
  	var time = new Date();
	
	time.setMonth(parseInt(document.getElementById("verify-month").value)-1);
	time.setDate(parseInt(document.getElementById("verify-day").value));
	time.setFullYear(parseInt(document.getElementById("verify-year").value));
	time.setMinutes(parseInt(document.getElementById("verify-minute").value));

	hours = parseInt(document.getElementById("verify-hour").value);
	if(hours==12)
	{
		if(document.getElementById("verify-ampm").value=="PM")
			hours = 12;
		else
			hours = 0;
	}
	else if(document.getElementById("verify-ampm").value=="PM")
		hours += 12;
	time.setHours(hours);
  
	arrdep = document.getElementById("verify-arrdep").selectedItem.value;
	window.opener.finishMBTADirections(time,arrdep);
}
