<!-- Writen by Brian Leonard: http://www.bleonard.com                    -->
<!-- Adapted from MapIt! by Jason Heddings: http://mapit.mozdev.org/     -->
<!-- License: http://creativecommons.org/licenses/by-nc-sa/2.0/          -->

var gMapIt = null;

////////////////////////////////////////////////////////////////////////////////
// Saves all settings to internal preferences.

function flush() {
  // general settings
  gMapItSettings.target = document.getElementById("target").selectedItem.value;

  // directions
  gMapItSettings.homeStreet = document.getElementById("home-street").value;
  gMapItSettings.homeCity = document.getElementById("home-city").value;
  gMapItSettings.homeState = document.getElementById("home-state").value;
  gMapItSettings.homeZip = document.getElementById("home-zip").value;
  gMapItSettings.homeName = document.getElementById("home-name").value;
  gMapItSettings.homeRide = document.getElementById("home-ride").checked;
  gMapItSettings.homeDrive = document.getElementById("home-drive").checked;

  gMapItSettings.workStreet = document.getElementById("work-street").value;
  gMapItSettings.workCity = document.getElementById("work-city").value;
  gMapItSettings.workState = document.getElementById("work-state").value;
  gMapItSettings.workZip = document.getElementById("work-zip").value;
  gMapItSettings.workName = document.getElementById("work-name").value;
  gMapItSettings.workRide = document.getElementById("work-ride").checked;
  gMapItSettings.workDrive = document.getElementById("work-drive").checked;
  
 // trip options
  gMapItSettings.tripWalking = document.getElementById("trip-walking").value;
  gMapItSettings.tripMinimize = document.getElementById("trip-minimize").value;
  gMapItSettings.tripAccess = document.getElementById("trip-access").checked;

  // time options
  gMapItSettings.timeVerify = document.getElementById("time-verify").checked;
  gMapItSettings.timeArrDep = document.getElementById("time-arrdep").selectedItem.value;
  gMapItSettings.timeDateType = document.getElementById("time-datetype").selectedItem.value;
  gMapItSettings.timeDateRel = document.getElementById("time-date-relative").value;
  gMapItSettings.timeMonth = document.getElementById("time-date-month").value;
  gMapItSettings.timeDay = document.getElementById("time-date-day").value;
  gMapItSettings.timeYear = document.getElementById("time-date-year").value;
  gMapItSettings.timeTimeType = document.getElementById("time-timetype").selectedItem.value;
  gMapItSettings.timeTimeRel = document.getElementById("time-time-relative").value;
  gMapItSettings.timeHour = document.getElementById("time-time-hour").value;
  gMapItSettings.timeMinute = document.getElementById("time-time-minute").value;
  gMapItSettings.timeAmPm = document.getElementById("time-time-ampm").value;

} //END: flush()

////////////////////////////////////////////////////////////////////////////////
// Sets all UI components based on saved internal settings.

function reload() {
  // general settings
  document.getElementById("target").selectedItem =
    document.getElementById(gMapItSettings.target);

  // directions
  document.getElementById("home-street").value = gMapItSettings.homeStreet;
  document.getElementById("home-city").value = gMapItSettings.homeCity;
  document.getElementById("home-state").value = gMapItSettings.homeState;
  document.getElementById("home-zip").value = gMapItSettings.homeZip;
  document.getElementById("home-name").value = gMapItSettings.homeName;
  document.getElementById("home-ride").checked = gMapItSettings.homeRide;
  document.getElementById("home-drive").checked = gMapItSettings.homeDrive;
  
   // directions
  document.getElementById("work-street").value = gMapItSettings.workStreet;
  document.getElementById("work-city").value = gMapItSettings.workCity;
  document.getElementById("work-state").value = gMapItSettings.workState;
  document.getElementById("work-zip").value = gMapItSettings.workZip;
  document.getElementById("work-name").value = gMapItSettings.workName;
  document.getElementById("work-ride").checked = gMapItSettings.workRide;
  document.getElementById("work-drive").checked = gMapItSettings.workDrive;
  
  //trip options
  document.getElementById("trip-walking").value = gMapItSettings.tripWalking;
  document.getElementById("trip-minimize").value = gMapItSettings.tripMinimize;
  document.getElementById("trip-access").checked = gMapItSettings.tripAccess;
  
  // time options
  document.getElementById("time-verify").checked = gMapItSettings.timeVerify;
  document.getElementById("time-arrdep").selectedItem = document.getElementById(gMapItSettings.timeArrDep);
  document.getElementById("time-datetype").selectedItem = document.getElementById(gMapItSettings.timeDateType);
  document.getElementById("time-date-relative").value = gMapItSettings.timeDateRel;
  document.getElementById("time-date-month").value = gMapItSettings.timeMonth;
  document.getElementById("time-date-day").value = gMapItSettings.timeDay;
  document.getElementById("time-date-year").value = gMapItSettings.timeYear;
  document.getElementById("time-timetype").selectedItem = document.getElementById(gMapItSettings.timeTimeType);
  document.getElementById("time-time-relative").value = gMapItSettings.timeTimeRel;
  document.getElementById("time-time-hour").value = gMapItSettings.timeHour;
  document.getElementById("time-time-minute").value = gMapItSettings.timeMinute;
  document.getElementById("time-time-ampm").value = gMapItSettings.timeAmPm;
  
} //END: reload()


////////////////////////////////////////////////////////////////////////////////
// Event Handler: called when "Ok" button is pressed.

function onOK() {
  flush();
} //END: onOK

////////////////////////////////////////////////////////////////////////////////


function onLoad() {
  gMapItSettings = new MapItSettings();
  // show the right relative/specifics in the time options
  dateIsSpecific(gMapItSettings.timeDateType=="dateS");
  timeIsSpecific(gMapItSettings.timeTimeType!="timeR");
  reload();
} //END: onLoad

