<!-- Writen by Brian Leonard: http://www.bleonard.com                    -->
<!-- Adapted from MapIt! by Jason Heddings: http://mapit.mozdev.org/     -->
<!-- License: http://creativecommons.org/licenses/by-nc-sa/2.0/          -->

function MapItSettings() { this._init(); }

////////////////////////////////////////////////////////////////////////////////

MapItSettings.prototype = {

  _init:function() { },

////////////////////////////////////////////////////////////////////////////////
  
  get _prefroot() { return "extensions.mbta.opts."; },

////////////////////////////////////////////////////////////////////////////////
  
  get target()    { return this._getPref("gen", "target", "top"); },
  set target(str) { this._setPref("gen", "target", str); },


////////////////////////////////////////////////////////////////////////////////

  get homeStreet()    { return this._getPref("home", "street", "1 Patriot Place"); },
  set homeStreet(str) { this._setPref("home", "street", str); },

////////////////////////////////////////////////////////////////////////////////

  get homeCity()    { return this._getPref("home", "city", "Foxboro"); },
  set homeCity(str) { this._setPref("home", "city", str); },

////////////////////////////////////////////////////////////////////////////////

  get homeState()    { return this._getPref("home", "state", "MA"); },
  set homeState(str) { this._setPref("home", "state", str); },

////////////////////////////////////////////////////////////////////////////////

  get homeZip()    { return this._getPref("home", "zip", "02035"); },
  set homeZip(str) { this._setPref("home", "zip", str); },

////////////////////////////////////////////////////////////////////////////////

  get homeName()    { return this._getPref("home", "name", "Foxboro"); },
  set homeName(str) { this._setPref("home", "name", str); },

////////////////////////////////////////////////////////////////////////////////

  get homeDrive()    { return this._getBool("home", "drive", 1); },
  set homeDrive(val) { this._setBool("home", "drive", val); },

////////////////////////////////////////////////////////////////////////////////

  get homeRide()    { return this._getBool("home", "ride", 0); },
  set homeRide(val) { this._setBool("home", "ride", val); },

////////////////////////////////////////////////////////////////////////////////

  get workStreet()    { return this._getPref("work", "street", "4 Yawkey Way"); },
  set workStreet(str) { this._setPref("work", "street", str); },

////////////////////////////////////////////////////////////////////////////////

  get workCity()    { return this._getPref("work", "city", "Boston"); },
  set workCity(str) { this._setPref("work", "city", str); },

////////////////////////////////////////////////////////////////////////////////

  get workState()    { return this._getPref("work", "state", "MA"); },
  set workState(str) { this._setPref("work", "state", str); },

////////////////////////////////////////////////////////////////////////////////

  get workZip()    { return this._getPref("work", "zip", "02215"); },
  set workZip(str) { this._setPref("work", "zip", str); },

////////////////////////////////////////////////////////////////////////////////

  get workName()    { return this._getPref("work", "name", "Fenway"); },
  set workName(str) { this._setPref("work", "name", str); },

////////////////////////////////////////////////////////////////////////////////

  get workDrive()    { return this._getBool("work", "drive", 0); },
  set workDrive(val) { this._setBool("work", "drive", val); },

////////////////////////////////////////////////////////////////////////////////

  get workRide()    { return this._getBool("work", "ride", 1); },
  set workRide(val) { this._setBool("work", "ride", val); },
  
////////////////////////////////////////////////////////////////////////////////

  get tripWalking()    { return this._getPref("trip", "walking", "0.50"); },
  set tripWalking(str) { this._setPref("trip", "walking", str); },

////////////////////////////////////////////////////////////////////////////////

  get tripMinimize()    { return this._getPref("trip", "minimize", "T"); },
  set tripMinimize(str) { this._setPref("trip", "minimize", str); },

////////////////////////////////////////////////////////////////////////////////

  get tripAccess()    { return this._getBool("trip", "access", 0); },
  set tripAccess(val) { this._setBool("trip", "access", val); },

////////////////////////////////////////////////////////////////////////////////

  get timeVerify()    { return this._getBool("time", "verify", 0); },
  set timeVerify(val) { this._setBool("time", "verify", val); },

////////////////////////////////////////////////////////////////////////////////

  get timeArrDep()    { return this._getPref("time", "arrdep", "A"); },
  set timeArrDep(str) { this._setPref("time", "arrdep", str); },

////////////////////////////////////////////////////////////////////////////////

  get timeDateType()    { return this._getPref("time", "datetype", "dateR"); },
  set timeDateType(str) { this._setPref("time", "datetype", str); },

////////////////////////////////////////////////////////////////////////////////

  get timeDateRel()    { return this._getPref("time", "date-relative", "tomorrow"); },
  set timeDateRel(str) { this._setPref("time", "date-relative", str); },

////////////////////////////////////////////////////////////////////////////////

  get timeMonth()    { return this._getPref("time", "date-month", "12"); },
  set timeMonth(str) { this._setPref("time", "date-month", str); },

////////////////////////////////////////////////////////////////////////////////

  get timeDay()    { return this._getPref("time", "date-day", "25"); },
  set timeDay(str) { this._setPref("time", "date-day", str); },

////////////////////////////////////////////////////////////////////////////////

  get timeYear()    { return this._getPref("time", "date-year", "2007"); },
  set timeYear(str) { this._setPref("time", "date-year", str); },

////////////////////////////////////////////////////////////////////////////////

  get timeTimeType()    { return this._getPref("time", "timetype", "timeS"); },
  set timeTimeType(str) { this._setPref("time", "timetype", str); },

////////////////////////////////////////////////////////////////////////////////

  get timeTimeRel()    { return this._getPref("time", "time-relative", "add60"); },
  set timeTimeRel(str) { this._setPref("time", "time-relative", str); },

////////////////////////////////////////////////////////////////////////////////

  get timeHour()    { return this._getPref("time", "time-hour", "9"); },
  set timeHour(str) { this._setPref("time", "time-hour", str); },

////////////////////////////////////////////////////////////////////////////////

  get timeMinute()    { return this._getPref("time", "time-minute", "0"); },
  set timeMinute(str) { this._setPref("time", "time-minute", str); },

////////////////////////////////////////////////////////////////////////////////

  get timeAmPm()    { return this._getPref("time", "time-ampm", "AM"); },
  set timeAmPm(str) { this._setPref("time", "time-ampm", str); },

////////////////////////////////////////////////////////////////////////////////

  // access the common opts elements
  _setOpts:function(mod, str) { nsPreferences.setUnicharPref(this._prefroot + mod, str); },
  _getOpts:function(mod) { return nsPreferences.copyUnicharPref(this._prefroot + mod, ""); },

////////////////////////////////////////////////////////////////////////////////

  // settings with integer values
  _setInt:function(mod, name, value) { this._setPref(mod, name, value); },
  _getInt:function(mod, name, dfault) { return parseInt(this._getPref(mod, name, dfault)); },

  // settings with boolean values
  _setBool:function(mod, name, value) { this._setInt(mod, name, (value) ? 1 : 0); },
  _getBool:function(mod, name, dfault) { return (this._getInt(mod, name, dfault) == 1) ? true : false; },

////////////////////////////////////////////////////////////////////////////////

  // settings with string values
  _setPref:function(mod, name, value) {
    var newopts = "";

    // remove the name from the current options, if it exists
    var pairs = this._getOpts(mod).split("&");
    for (var idx = 0; idx < pairs.length; idx++) {
      var pair = pairs[idx].split("=");
      if ((pair[0] != name) && (pairs[idx] != "")) {
        newopts += pairs[idx] + "&";
      }
    }

    // add the new string to the options & save the options
    newopts += name + "=" + escape(value);
    this._setOpts(mod, newopts);
  },

////////////////////////////////////////////////////////////////////////////////

  _getPref:function(mod, name, dfault) {
    // scan for the name
    var pairs = this._getOpts(mod).split("&");
    for (var idx = 0; idx < pairs.length; idx++) {
      var pair = pairs[idx].split("=");
      if (pair[0] == name) {
        return unescape(pair[1]);
      }
    }

    // still here?  not found...
    return dfault;
  },

////////////////////////////////////////////////////////////////////////////////
};
